<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/site.php";
include_once "include/common.php";
include_once "include/contacts.php";
include_once "include/orderby.php";

$database = site_prolog(PO_USER_TYPE_USER);

$folder_id = pg_escape_string($_REQUEST['folder']);

$folder_data = pg_fetch_row(pg_query($database, "select caption, date_of_creation, access_rights, parent_folder, description, users, password, event, thumb_ver, orderby from folder where identifier='$folder_id'"));

/* Ensure mere users don't edit an folder that isn't theirs! */
if (($po_user['id'] != $folder_data[5]) &&
    ($po_user['type'] != PO_USER_TYPE_ADMIN)) {
    site_referer_error('not_owner');
    site_epilog($database);
    exit();  
}

$folder_all = get_users_folder($database);

$folder_stats = pg_fetch_assoc(pg_query($database, "select count_subfolders_by_folder($folder_id, $po_user[id], '{".$passwords."}') as folders, count_photos_by_folder($folder_id, $po_user[id], '{".$passwords."}') as photos"));

$path_to_folder = get_path_to_folder($database, $folder_id);
site_header($strings['generic_edit_folder']);
site_navigator(5);
site_navigator_status(disp_user_string($database, $po_user['id'])." $path_to_folder : ".$strings['generic_edit_folder'], "");

print "&nbsp;<br/>\n";

print "<form method=\"post\" action=\"folder.edit.2.php\" accept-charset=\"".$strings['formats_encoding']."\">";
print "<input type=\"hidden\" name=\"folder\" value=\"$folder_id\"/>";
print "<table class=\"listing\">\n";
print "<tr>";
print emit_td($strings['generic_folder_name']);
print "<td><input type=\"text\" name=\"folder_caption\" value=\"$folder_data[0]\"/></td>";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_description']);
print "<td>";
print "<textarea name=\"folder_description\" rows=\"4\" cols=\"80\">$folder_data[4]</textarea>";
print "</td>";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_parent']);
print "<td>";
print emit_folder_combo("parent", $folder_all, $folder_data[3], "null");
print "</td>\n";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_access']);
print "<td>"; print emit_access_combo("folder_access_rights", $folder_data[2], ""); 
print "</td>\n";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_password']);
print "<td><input type=\"text\" name=\"password\" value=\"$folder_data[6]\" /></td>";
print "</tr>";
print "<tr>";
print emit_td($strings['datebook_event']);
print emit_td(emit_event_combo($database, "event", $po_user['id'], $folder_data[7]));
print "</tr>";

print "<tr>";
print emit_td($strings['generic_subfolders']);
print "<td>$folder_stats[folders]</td>\n";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_photos']);
print "<td>$folder_stats[photos]</td>\n";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_created']);
print "<td>".emit_date_html($folder_data[1], 'date'). "</td>";
print "</tr>";
print "<tr>";
print emit_td($strings['generic_order_by']);
print "<td>";
display_order_by_combo($folder_data[9]);
print "</td>";
print "</tr>";

if ($folder_data[8]) {
  print "<tr>";
  print emit_td($strings['generic_keep_thumb']);
  print "<td>";
  $img = "<img src=\"".generate_link('image', '', array('ver'=>$folder_data[8], 'size'=>1)) ."\" alt=\"\" />&nbsp;";
  print emit_a(generate_link('photo', '', array('ver'=>$folder_data[8])),
	       $img);
  print emit_yes_no_combo("keep_thumb", "t");
  print "</td>";
  print "</tr>";
} else {
  print "<input type=\"hidden\" name=\"keep_thumb\" value=\"f\"/>";
}
print "</table>";

print "<input type=\"hidden\" name=\"return\" value=\"$_SERVER[HTTP_REFERER]\"/>";

print "<div align=\"center\">\n";
print $thm_elem['button.save.changes'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</div>\n";
print "</form>";

site_footer($database);
site_epilog($database);
?>
