<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$profile_data = array();

function profile_i18n_data() {
  global $profile_data;
  global $strings;

  $profile_data = array("lens"         => array("idx" => 1, 'link' => "my.profile.php?selector=1",  "alt" => $strings['generic_lenses']),
                      "camera"       => array("idx" => 2, 'link' => "my.profile.php?selector=2",  "alt" => $strings['generic_cameras']),
                      "flash"        => array("idx" => 3,  'link' => "my.profile.php?selector=3",  "alt" => $strings['generic_flashes']),
                      "scanner"      => array("idx" => 4, 'link' => "my.profile.php?selector=4",  "alt" => $strings['generic_scanners']),
                      "filter"       => array("idx" => 5, 'link' => "my.profile.php?selector=5",  "alt" => $strings['generic_filters']),
                      "film"         => array("idx" => 6, 'link' => "my.profile.php?selector=6",  "alt" => $strings['generic_films']),
                      "support"      => array("idx" => 7, 'link' => "my.profile.php?selector=7",  "alt" => $strings['generic_supports']),
                      "manufacturer" => array("idx" => 8, 'link' => "my.profile.php?selector=8",  "alt" => $strings['generic_manufacturers']),
                      "label"        => array("idx" => 9, 'link' => "my.profile.php?selector=9",  "alt" => $strings['generic_labels']),
                      "location"     => array("idx" => 10, 'link' => "my.profile.php?selector=10", "alt" => $strings['generic_locations']));
}

$generate_i18n_data[] = "profile_i18n_data";

function display_camera($database, $viewer_id, $owner_id) {
  global $access;
  global $icc_profiles;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                          from view_camera where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                            from view_camera where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                            from view_camera where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of_cameras = pg_num_rows($all_cameras);
  if ($viewer_id!=$owner_id && $num_of_cameras == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['profile_model'], "width=\"25%\"");
  print emit_th($strings['profile_serial'], "width=\"13%\"");
  print emit_th($strings['profile_purchased'], "width=\"16%\"");
  print emit_th($strings['profile_new'], "width=\"5%\"");
  print emit_th($strings['profile_ignore_comment'], "width=\"10%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic_photos'], "width=\"5%\"");
    print emit_th($strings['generic_access'], "width=\"5%\"");
    print emit_th($strings['profile_icc_profile'], "width=\"10%\"");
    print "<th width=\"7%\" colspan=\"2\">".emit_a("camera.add.php",$strings['generic_add'])."</th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_cameras; $i++) {
    $camera = pg_fetch_row($all_cameras, $i);
    print "<tr>\n";
    print emit_td($camera[0]);
    print emit_td(emit_a($camera[7], $camera[1]) ." $camera[2] $camera[3]");
    print emit_td($camera[4]);
    print emit_td(emit_date_html($camera[5], 'date'));
    print emit_td(emit_yes_no_text($camera[6]));
    print emit_td(emit_yes_no_text($camera[11]));
    if ($viewer_id==$owner_id) {
      print emit_td($camera[10]);
      print emit_td($strings['generic_'.$access[$camera[8]]]);
      if ($camera[9] != "")
	print emit_td($icc_profiles[$camera[9]]['name']);
      else 
	print emit_td("");
      print emit_td(emit_a("camera.edit.php?item=$camera[0]", $strings['generic_edit']));
      print emit_td(emit_a("camera.del.php?item=$camera[0]", $strings['generic_delete']));
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_profile($database, $type, $owner_id) {
  global $access;
  global $strings;

  $all = pg_query($database, "select identifier, name, model, serial, purchase_date, purchased_new, s_url, m_url, access_rights, number_of_equipment_references(identifier) as photos
                                          from view_equipment where users=$owner_id and type = $type order by name, model");

  $num_of = pg_num_rows($all);

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['profile_model'], "width=\"35%\"");
  print emit_th($strings['profile_serial'], "width=\"13%\"");
  print emit_th($strings['profile_purchased'], "width=\"16%\"");
  print emit_th($strings['profile_new'], "width=\"5%\"");
  print emit_th($strings['generic_photos'], "width=\"5%\"");
  print emit_th($strings['generic_access'], "width=\"10%\"");
  print "<th width=\"7%\" colspan=\"2\">".emit_a("profile.add.php?type=$type", $strings['generic_add'])."</th>\n";
  print "</tr>\n";

  for ($i=0; $i < $num_of; $i++) {
    $item = pg_fetch_assoc($all, $i);
    print "<tr>\n";
    print emit_td($item['identifier']);
    if ($item['m_url'])
      $item['name'] = emit_a($item['m_url'], $item['name']);
    if ($item['s_url'])
      $item['model'] = emit_a($item['s_url'], $item['model']);
    print emit_td("$item[name] $item[model]");
    print emit_td($item['serial']);
    print emit_td(emit_date_html($item['purchase_date'], 'date'));
    print emit_td(emit_yes_no_text($item['purchased_new']));
    print emit_td($item['photos']);
    print emit_td($strings['generic_'.$access[$item['access_rights']]]);
    print emit_td(emit_a("profile.edit.php?type=$type&amp;item=$item[identifier]", $strings['generic_edit']));
    print emit_td(emit_a("profile.del.php?type=$type&amp;item=$item[identifier]", $strings['generic_delete']));
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_film($database, $viewer_id, $owner_id) {
  global $access;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights,  number_of_film_references(identifier) as photos
                                        from view_film where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights, number_of_film_references(identifier) as photos
                                          from view_film where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights, number_of_film_references(identifier) as photos
                                          from view_film where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of_films = pg_num_rows($all_films);
  if ($viewer_id!=$owner_id && $num_of_films == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['profile_model'], "width=\"35%\"");
  print emit_th($strings['profile_iso'], "width=\"7%\"");
  print emit_th($strings['profile_format'], "width=\"20%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic_photos'], "width=\"5%\"");
    print emit_th($strings['generic_access'], "width=\"10%\"");
    print "<th width=\"10%\" colspan=\"2\">".emit_a("film.add.php", $strings['generic_add'])."</th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_films; $i++) {
    $film = pg_fetch_row($all_films, $i);
    print "<tr>\n";
    print emit_td($film[0]);
    print emit_td(emit_a($film[5], $film[1]) ." $film[2]");
    print emit_td($film[3]);
    print emit_td($film[4]);
    if ($viewer_id==$owner_id) {
      print emit_td($film[7]);
      print emit_td($strings['generic_'.$access[$film[6]]]);
      print emit_td(emit_a("film.edit.php?item=$film[0]",$strings['generic_edit']));
      print emit_td(emit_a("film.del.php?item=$film[0]",$strings['generic_delete']));
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_manufacturer($database, $show_add = TRUE) {
  global $access;
  global $strings;
  global $po_user;

  $viewer_id = $po_user['id'];

  $all_manufacturers = pg_query($database, "select identifier, name, url, last_modified_date, last_modifying_users from manufacturer order by name");

  $num_of_manufacturers = pg_num_rows($all_manufacturers);
  if (!$show_add && ($num_of_manufacturers == 0)) return;

  print "<table class=\"profile\">\n";
  if ($show_add) {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"6\">".sprintf($strings['profile_all'], $strings['generic_manufacturers'])."</td>\n";
    print "</tr>\n";
  }

  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['generic_name'], "width=\"25%\"");
  print emit_th($strings['user_web'], "width=\"40%\"");
  print emit_th($strings['generic_created'], "width=\"20%\"");
  if ($show_add) {
    print "<th width=\"10%\" colspan=\"2\">".emit_a("manufacturer.add.php", $strings['generic_add'])."</th>\n";
  } else {
      print "<th></th><th></th>";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_manufacturers; $i++) {
    $manufacturer = pg_fetch_row($all_manufacturers, $i);
    print "<tr>\n";
    print emit_td($manufacturer[0]);
    print emit_td($manufacturer[1]);
    print emit_td(emit_a($manufacturer[2], $manufacturer[2]));
    print emit_td(emit_date_html($manufacturer[3], 'date'));
    if ($show_add && ($po_user['id'] == $manufacturer[4]) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      print emit_td(emit_a("manufacturer.edit.php?item=$manufacturer[0]", $strings['generic_edit']));
      print emit_td(emit_a("manufacturer.del.php?item=$manufacturer[0]", $strings['generic_delete']));
    } else {
      print "<td></td><td></td>";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_label($database, $show_add = TRUE) {
  global $po_user;
  global $strings;
  
  $all_labels = pg_query($database, "
      select label.identifier,
             (select url from manufacturer where identifier=label.manufacturer),
             (select name from manufacturer where identifier=label.manufacturer),
             label.name, paper.name,
             space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
             columns, rows, date_of_creation, users
        from label, paper
       where label.paper=paper.identifier
       order by label.identifier");

  $num_of_labels = pg_num_rows($all_labels);
  if (!$show_add && ($num_of_labels == 0)) return;
  
  print "<table class=\"profile\">\n";
  if ($show_add) {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"13\">".sprintf($strings['profile_all'], $strings['generic_labels'])."</td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['profile_model'], "width=\"25%\"");
  print emit_th($strings['label_h_space'], "width=\"5%\"");
  print emit_th($strings['label_v_space'], "width=\"5%\"");
  print emit_th($strings['label_width'], "width=\"5%\"");
  print emit_th($strings['label_height'], "width=\"5%\"");
  print emit_th($strings['label_h_offset'], "width=\"5%\"");
  print emit_th($strings['label_v_offset'], "width=\"5%\"");
  print emit_th($strings['label_rows'], "width=\"5%\"");
  print emit_th($strings['label_columns'], "width=\"5%\"");
  print emit_th($strings['generic_created'], "width=\"20%\"");
  if ($show_add) {
    print "<th width=\"10%\" colspan=\"2\">".emit_a("label.add.php",$strings['generic_add'])."</th>\n";
  } else {
      print "<th></th><th></th>";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_labels; $i++) {
    $label = pg_fetch_row($all_labels, $i);
    print "<tr>\n";
    print emit_td($label[0]);
    print emit_td(emit_a($label[1], $label[2]) ." $label[3], $label[4]");
    print emit_td($label[5]);
    print emit_td($label[6]);
    print emit_td($label[7]);
    print emit_td($label[8]);
    print emit_td($label[9]);
    print emit_td($label[10]);
    print emit_td($label[11]);
    print emit_td($label[12]);
    print emit_td(emit_date_html($label[13], 'date'));
    if ($show_add && ($po_user['id'] == $label[14]) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      print emit_td(emit_a("label.edit.php?item=$label[0]",$strings['generic_edit']));
      print emit_td(emit_a("label.del.php?item=$label[0]",$strings['generic_delete']));
    } else {
      print "<td></td><td></td>";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_location($database, $show_add = TRUE) {
  global $po_user;
  global $strings;

  $viewer_id = '*';

  if ($po_user['type'] == PO_USER_TYPE_ADMIN)
    $filter = "";
  else
    $filter = " where private is false ";

  $result = pg_query($database, "
  select view_location.identifier, place, city, state, country,
         last_modified_date, latitude, longitude,
         number_of_location_references(view_location.identifier, $po_user[id]) as photos,
         private, users,
         number_of_location_references(view_location.identifier) as photos2
    from view_location
         $filter
order by country, state, city, place");
  $num = pg_num_rows($result);

  print "<table class=\"profile\">\n";
  if ($show_add) {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"9\">".sprintf($strings['profile_all'], $strings['generic_locations'])."</td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print emit_th($strings['profile_id_no'], "width=\"5%\"");
  print emit_th($strings['generic_description'], "width=\"40%\"");
  print emit_th($strings['photo_geolocation'], "width=\"16%\"");
  print emit_th($strings['generic_created'], "width=\"12%\"");
  print emit_th($strings['generic_photos'], "width=\"8%\"");
  print emit_th($strings['generic_private'], "width=\"5%\"");
  if ($show_add) {
    print "<th width=\"10%\" colspan=\"2\">".emit_a("location.add.php", $strings['generic_add'])."</th>\n";
  } else {
    print "<th></th><th></th>";
  }
  print "</tr>\n";

  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_row($result, $i);
    if ($r[1] != '' && ($r[2] != '' || $r[3] != '' ||  $r[4] != '')) {
      $r[1] = sprintf("%s,", $r[1]);
    }
    if ($r[2] != '' && ($r[3] != '' ||  $r[4] != '')) {
      $r[2] = sprintf("%s,", $r[2]);
    }
    if ($r[3] != '' && $r[4] != '') {
      $r[3] = sprintf("%s,", $r[3]);
    }
    print "<tr>\n";
    print emit_td($r[0]);

    if ($r[1] == 'Unknown') {
      $foo = $strings['generic_unknown'];
    } else {
      $foo = "$r[1] $r[2] $r[3] $r[4]";
      $foo = emit_a("http://maps.google.com/maps?q=$foo=h", $foo, "target=\"_new\"");
    }

    print emit_td($foo);
    if ($r[6] || $r[7]) {
      $dispstr = latitude_dms($r[6], 'latitude');
      $dispstr .= '  ' . latitude_dms($r[7], 'longitude');
      print emit_td(emit_a("http://maps.google.com/maps?q=$r[6]+$r[7]($r[1] $r[2] $r[3] $r[4])&amp;t=h", $dispstr, "target=\"_new\""));
    } else {
      print emit_td('');
    }
    print emit_td(emit_date_html($r[5], 'date'));
    $r[11] -= $r[8];
    if ($r[11]) {
      print emit_td("$r[8] ($r[11])");
    } else {
      print emit_td($r[8]);
    }
    if ($r[0]) {
      print emit_td(emit_yes_no_text($r[9]));
    } else {
      print emit_td('');
    }
    if ($show_add && ($po_user['id'] == $r[10]) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      print emit_td(emit_a("location.edit.php?item=$r[0]",$strings['generic_edit']));
      print emit_td(emit_a("location.del.php?item=$r[0]",$strings['generic_delete']));
    } else {
      print "<td></td><td></td>";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

/* type is:  camera film label */
function old_profile_del_item ($database, $type, $identifier)
{
  global $po_user;
  global $strings;

  $type = pg_escape_string($type);
  $identifer = pg_escape_string($identifier);

  $type_to_remove = FALSE;

  if ($identifier != "") {

    /* Ensure the user owns it !*/
    if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
      $result = pg_fetch_row(pg_query($database, "select count(identifier) from $type where identifier=$identifier and users=$po_user[id]"));
      if ($result[0] == 0) {
	return FALSE;
      }
    }

    pg_query($database, "begin");
    if ($type != 'label') {
      $number_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from $type where type=(select type from $type where identifier='$identifier')"));
      if ($number_of_same_type[0] == 1) {
	$type_to_remove = pg_fetch_row(pg_query($database, "select type from $type where identifier='$identifier'"));
      }
    }

    $result = pg_query($database, "delete from $type where identifier='$identifier'");
    if (!$result) {
      pg_query($database, "rollback");
      site_push_error($strings['errors_db_insert_failed']);
      return FALSE;
    }

    if ($type != 'label') {
      if ($number_of_same_type[0] == 1) {
	$result = pg_query($database, "delete from ".$type."_type where identifier='$type_to_remove[0]'");
	if (!$result) {
	  pg_query($database, "rollback");
	  site_push_error($strings['errors_db_insert_failed']);
	  return FALSE;
	}
      }
    }
    pg_query($database, "commit");
  }
  return TRUE;
}
			   
?>
