<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$tools_data = array();

function tools_i18n_data() {
  global $strings;
  global $tools_data;

  $tools_data = array("bulkupdate"      => array("idx" => 1, 'link' => "my.tools.php?selector=1", "alt" => $strings['generic_bulk_update']),
		      "generator"       => array("idx" => 2, 'link' => "my.tools.php?selector=2", "alt" => $strings['tools_xml_template_generator']));
}

$generate_i18n_data[] = "tools_i18n_data";

include_once "common.php";

function display_xml_template_generator($database) {
  global $thm_elem;
  global $strings;
  global $po_user;

  print "<form method=\"post\" action=\"xml.generator.php\" enctype=\"multipart/form-data\" accept-charset=\"".$strings['formats_encoding']."\">\n";

  print "<table class=\"listing\">\n";
  print "<tr class=\"folder_top\">\n";
  print "<td colspan=\"2\">".$strings['tools_fill_in_image_details']."</td>\n";
  print "</tr>\n";
  print "<tr>".emit_td($strings['tools_base_file']);
  print "<td>";
  print "<input type=\"text\" name=\"file_name\" class=\"storage\" value=\"\" title=\"".$strings['tools_base_name']."\"/>";

  print "<select name=\"file_number_digits\" title=\"".$strings['tools_digits']."\">";
  for ($i=1; $i < 11; $i++) {
    print emit_option($i, $i, FALSE);
  }
  print "</select>";
  print " . <input type=\"text\" name=\"file_format\" value=\"\" class=\"storage\" title=\"".$strings['tools_file_format']."\" />";

  print "</td>\n</tr>\n";
  print "<tr>".emit_td($strings['tools_start_num'])."<td>";
  print "<input type=\"text\" name=\"file_number_start\" class=\"storage\" value=\"\" title=\"".$strings['tools_start_num_text']."\" />";
  print "</td>\n</tr>\n";
  print "<tr>".emit_td($strings['tools_num_photos'])."<td>";
  print "<input type=\"text\" name=\"frame_number\" value=\"\" class=\"storage\" title=\"".$strings['tools_num_photos_text']."\"  />";
  print "</td>\n</tr>\n";
  print "<tr><td>Folder</td><td>";
  print emit_folder_combo("folder", get_users_folder($database), "", "");
  print "</td></tr>\n";

  $values = array('copyright' => $po_options['copyright_default'],
		  'author' => "$po_user[first_name] $po_user[last_name]",
		  'web_statement' => $po_options['web_statement_default'],
		  'hide_original' => $po_options['hide_originals_default'],
		  'access_rights' => $po_options['access_default']);

  print emit_iptc_form($database, FALSE, $values);

  print "<tr><td>".$strings['import_storage_location']."</td><td>";
  print emit_storage_location_combo("storage_location_type", "");
  print "<input type=\"text\" name=\"storage_location_id\" class=\"storage\" title=\"".$strings['import_storage_location_id']."\" /> -
         <input type=\"text\" name=\"storage_index\" class=\"storage\" title=\"".$strings['import_storage_location_index']."\"/> :
         <input type=\"text\" name=\"storage_size\" class=\"storage\" title=\"".$strings['import_storage_location_size']."\"/>";
  print "</td></tr>\n";

  print emit_photo_tech_form($database, FALSE);
  print emit_equipment_form($database, FALSE);

  print "</table>\n";
  print $thm_elem['button.submit'];
  print $thm_elem['button.clear'];
  print "</form>\n";
}

function display_bulk_update($database, $url, $type, $selection) {
  global $po_user;
  global $thm_elem;
  global $strings;

  $num_photos = photos_in_spool($database);

  /* Come up with a sane default for type */
  if ($type == FALSE) {
    if ($num_photos > 0) {
      $type = "spool";
    } else {
      $type = "folder";
    }
  }

  print "<form method=\"post\" action=\"bulk.update.php\" enctype=\"multipart/form-data\" accept-charset=\"".$strings['formats_encoding']."\">\n";

  print "<table class=\"listing\">\n";
  print "<tr class=\"folder_top\">\n";
  print "<td colspan=\"2\">".$strings['generic_search_criteria']."</td>\n";
  print "</tr>\n";
  if ($type == "folder") {
    $checked = "checked=\"checked\"";
    $sel = $selection;
  } else {
    $checked = "";
    $sel = "";
  }
  print "<tr>";
  print emit_td($strings['generic_folder'] . " <input type=\"radio\" name=\"type\" value=\"folder\" $checked />");
  print "<td>";
  print emit_folder_combo("select_folder", get_users_folder($database), $sel, "all");
  print "<input type=\"checkbox\" name=\"recursive[]\" value=\"folder\" /> ".$strings['generic_recursive']."</td></tr>\n";
  if ($type == "album") {
    $checked = "checked=\"checked\"";
    $sel = $selection;
  } else {
    $checked = "";
    $sel = "";
  }
  print "<tr>";
  print emit_td($strings['generic_album'] ." <input type=\"radio\" name=\"type\" value=\"album\" $checked />");
  print "<td>";
  print emit_album_combo("select_album", get_users_album($database), $sel, "null");
  print "<input type=\"checkbox\" name=\"recursive[]\" value=\"folder\" /> ".$strings['generic_recursive']."</td></tr>\n";
  if ($num_photos > 0) {
    if ($type == "spool")
      $checked = "checked=\"checked\"";
    else 
      $checked = "";
    print "<tr>";
    print emit_td(emit_a(generate_link('album', $po_user['spool_album']),
			 $strings['spool_name']).
		  "<input type=\"radio\" name=\"type\" value=\"spool\" $checked/>");
    print emit_td($strings['spool_photos_in'].": $num_photos");;
    print "</tr>\n";
  }
  if ($selection != "" && $type == "list") {
    $checked = "checked=\"checked\"";
    
    print "<tr><td>".$strings['generic_selection']." <input type=\"radio\" name=\"type\" value=\"list\" $checked/></td><td>";
    print "<input type=\"hidden\" name=\"selection\" value=\"$selection\" />";
    $array = explode(",", $selection);
    foreach ($array as $item) {
      print emit_a(generate_link('photo', $item), "# $item");
    }
    print "</td></tr>\n";
  }
  print "</table>\n";

  print "<table class=\"listing\">\n";
  print "<tr class=\"folder_top\">\n";
  print "<td colspan=\"2\">".$strings['generic_action']."</td>\n";
  print "</tr>\n";
  print "<tr>".emit_td($strings['tools_regenerate_thumb']);
  print emit_td(emit_yes_no_combo("set_generate_images", 'f'));
  print "</tr>\n";

  print emit_iptc_form($database, TRUE);
  print emit_photo_tech_form($database, TRUE);
  print emit_equipment_form($database, TRUE);
  
  print "</table>\n";
  print $thm_elem['button.submit'];
  print $thm_elem['button.clear'];
  print "</form>\n";
}

?>
