<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/print.ps.php";
include_once "include/orderby.php";

$database = site_prolog(PO_USER_TYPE_USER);

$print_type = $_REQUEST['print_type'];

$photos_in_spooler = pg_query($database, "select photo.identifier, photo.caption, album_content.version from album_content, photo where photo.identifier=album_content.photo and album_content.album = $po_user[spool_album] group by photo.identifier, photo.folder, photo.caption, album_content.version");

$num_photos = pg_num_rows($photos_in_spooler);

site_header($strings['generic_print']);
site_navigator(5);
site_navigator_status("", $strings['spool_photos_in'] ." : $num_photos");

if ($print_type == "label") {
  $all_labels = pg_query($database, "
    select label.identifier,
           (select name from manufacturer where identifier=label.manufacturer),
           label.name, paper.name
      from label, paper
     where label.paper=paper.identifier");

  if (isset($_REQUEST['label']))
    $po_options['label'] = $_REQUEST['label'];

  $current_label = pg_fetch_row(pg_query($database, "
    select space_x, space_y, label.size_x, label.size_y, offset_x, offset_y, columns, rows, paper, paper.size_x, paper.size_y
      from label, paper
     where label.identifier=$po_options[label]
       and label.paper=paper.identifier"));
  $x_space       = $current_label[0];
  $y_space       = $current_label[1];
  $x_size        = $current_label[2];
  $y_size        = $current_label[3];
  $left_margin   = $current_label[4];
  $right_margin  = $current_label[4];
  $top_margin    = $current_label[5];
  $bottom_margin = $current_label[5];
  $columns       = $current_label[6];
  $rows          = $current_label[7];

  $paper_name    = $current_label[ 8];
  $paper_width   = $current_label[ 9];
  $paper_height  = $current_label[10];

  print "<form method=\"post\" action=\"print.2.php\" accept-charset=\"".$strings['formats_encoding']."\">\n";

  print $strings['generic_label'] ." :\n";

  print "<select onchange=\"location = 'print.php?print_type=$print_type&amp;label=' + this.options[this.selectedIndex].value;\">\n";
  for ($i=0; $i < pg_num_rows($all_labels); $i++) {
    $labels = pg_fetch_row($all_labels, $i);
    print emit_option("$labels[0]", "$labels[1] $labels[2], $labels[3]", $labels[0] == $po_options['label']);
  }
  print "</select>";

  print "<table class=\"print\" width=\"100%\" >\n";
  print "<tr><td align=\"left\" valign=\"middle\" colspan=\"2\">\n";

  display_label_layout($left_margin, $top_margin, $x_size, $y_size, $x_space, $y_space, $columns, $rows, TRUE);
  print "</td></tr>\n";
} else {
  $all_papers = pg_query($database, "select identifier, name, size_x, size_y from paper");

  if (isset($_REQUEST['paper']))
    $po_options['paper'] = $_REQUEST['paper'];

  $left_margin   = 20;
  $top_margin    = 20;
  $right_margin  = 20;
  $bottom_margin = 20;
  $columns       = 4;
  $x_space       = 5;
  $y_space       = 2;
  $x_size        = 0;
  $y_size        = 0;

  $current_paper = pg_fetch_row(pg_query($database, "select name, size_x, size_y from paper where identifier=$po_options[paper]"));

  $paper_name    = $current_paper[0];
  $paper_width   = $current_paper[1];
  $paper_height  = $current_paper[2];

  print "<form method=\"post\" action=\"print.2.php\" accept-charset=\"".$strings['formats_encoding']."\">\n";
  print $strings['label_paper_size'] .": &nbsp;\n";
  print "<select onchange=\"location = 'print.php?print_type=$print_type&amp;paper=' + this.options[this.selectedIndex].value;\">\n";
  for ($i=0; $i < pg_num_rows($all_papers); $i++) {
    $papers = pg_fetch_row($all_papers, $i);
    print emit_option("$papers[0]", $papers[1], $papers[0] == $po_options['paper']);
  }
  print "</select>\n";

  print "<input type=\"hidden\" name=\"x_space\" value=\"$x_space\"/>\n";
  print "<input type=\"hidden\" name=\"y_space\" value=\"$y_space\"/>\n";
  print "<input type=\"hidden\" name=\"x_size\"  value=\"$x_size\"/>\n";
  print "<input type=\"hidden\" name=\"y_size\"  value=\"$y_size\"/>\n";

  print "<table class=\"print\"><tr>\n";
  print "<th align=\"center\" colspan=\"3\">".$strings['label_margin']."</td><th>&nbsp;&nbsp;&nbsp;</th>\n";
  print "<th align=\"center\">".$strings['label_columns']."</th><th>&nbsp;&nbsp;&nbsp;</th>\n";
  print "<th align=\"center\" colspan=\"2\">".$strings['label_spacing']."</th><th>&nbsp;&nbsp;&nbsp;&nbsp;</th>\n";
  print "<th align=\"center\" colspan=\"3\">".$strings['label_orientation']."</th>\n";
  print "</tr>";
  print "<tr>\n<td></td><td align=\"center\">";
  print "<input type=\"text\" name=\"top_margin\" value=\"$top_margin\" size=\"4\"/></td><td></td><td></td>";
  print "<td align=\"center\" >";
  print "<select name=\"columns\">\n";
  for ($i=1; $i < 11; $i++) {
    print emit_option($i, $i, $columns == $i);
  }
  print "</select>\n";
  print "</td>\n";
  print "<td></td>\n";
  print "<td></td>\n";
  print "<td align=\"center\"><input type=\"text\" name=\"x_space\" value=\"$x_space\" size=\"4\"/>\n</td>\n";
  print "<td></td>\n";
  print "<td align=\"center\"><input type=\"radio\" name=\"orientation\" value=\"0\" checked=\"checked\" />".$strings['label_portrait'] ."</td>\n";
  print "<td>&nbsp;</td>\n";
  print "<td align=\"center\"><input type=\"radio\" name=\"orientation\" value=\"1\"/>".$strings['label_landscape']."</td>\n";
  print "</tr>\n";

  print "<tr>\n<td align=\"center\">\n<input type=\"text\" name=\"left_margin\" value=\"$left_margin\" size=\"4\" align=\"right\"/>\n</td>\n";
  print "<td>\n<img src=\"themes/print.layout.gif\" alt=\"\"/>\n</td>";
  print "<td align=\"center\">\n<input type=\"text\" name=\"right_margin\" value=\"$right_margin\" size=\"4\"/>\n</td>\n";

  print "<td></td>\n";
  print "<td><img src=\"themes/print.layout.4.gif\"  alt=\"\" />\n</td>";
  print "<td></td>\n";
  print "<td><input type=\"text\" name=\"y_space\" value=\"$y_space\" size=\"4\" align=\"right\"/></td>\n";
  print "<td><img src=\"themes/print.layout.spacing.gif\" alt=\"\" />\n</td>";
  print "<td></td>\n";
  print "<td><img src=\"themes/print.orient.portrait.gif\" alt=\"\" /></td>";
  print "<td></td>\n";

  print "<td><img src=\"themes/print.orient.landscape.gif\" alt=\"\" /></td>";
  print "</tr>\n";
  print "<tr>\n<td></td><td align=\"center\"><input type=\"text\" name=\"bottom_margin\" value=\"$bottom_margin\" size=\"4\"/>\n</td><td></td>\n";
  print "<td colspan=\"9\"></td>\n";
  print "</tr></table>\n";
}

print "<p>".$strings['label_details']."</p>";

print "<table class=\"folder\"><tr><td width=\"33%\">\n";

if ($print_type == "brochure") {
  print "<input type=\"checkbox\" name=\"display_image\"  checked=\"checked\" />".$strings['generic_image']."<br/>\n";
}
print "<input type=\"checkbox\" name=\"display_barcode\" checked=\"checked\" />".$strings['generic_barcode']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_title\"   checked=\"checked\" />".$strings['generic_title']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_caption\" checked=\"checked\" />".$strings['generic_caption']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_location\" checked=\"checked\" />".$strings['generic_location']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_copyright\" checked=\"checked\" />".$strings['generic_copyright']."<br/>\n";
print "</td><td width=\"33%\">";
print "<input type=\"checkbox\" name=\"display_camera\" checked=\"checked\" />".$strings['generic_camera']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_camera_program\" checked=\"checked\" />".$strings['generic_camera_program']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_camera_meter\" checked=\"checked\" />".$strings['generic_camera_metering']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_shutter\" checked=\"checked\" />".$strings['generic_shutter']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_aperture\" checked=\"checked\" />".$strings['generic_aperture']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_exp_comp\" checked=\"checked\" />".$strings['generic_exp_comp']."<br/>\n";
print "</td><td width=\"33%\">";
print "<input type=\"checkbox\" name=\"display_focal_length\" checked=\"checked\" />".$strings['generic_focal_length']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_flash_mode\" checked=\"checked\" />".$strings['generic_flash_mode']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_flash_comp\" checked=\"checked\" />".$strings['generic_flash_comp']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_iso\" checked=\"checked\" />".$strings['profile_iso']."<br/>\n";
print "<input type=\"checkbox\" name=\"display_iso_override\" checked=\"checked\" />".$strings['generic_iso_override']."<br/>\n";
print "</td></tr></table>\n";

print "<p>".$strings['label_output'].":\n";
print emit_print_format_combo("output_format", $po_options['print_out']);
print "&nbsp;&nbsp;&nbsp;&nbsp;".$strings['generic_order_by'].": \n";
display_order_by_combo(5);
print "</p>";

$dupes_found = 0;

for ($photos=0; $photos < pg_num_rows($photos_in_spooler); $photos++) {
  $photo_identifier = pg_fetch_assoc($photos_in_spooler, $photos);
  $photo_dupes = pg_query($database, "select photo_dupe.identifier, photo_dupe.key, date_of_creation, storage_location, storage_index, remark from photo_dupe where photo=$photo_identifier[identifier] order by date_of_creation");
  if (pg_num_rows($photo_dupes) > 1) {
    if ($dupes_found == 0) {
      $dupes_found = 1;
      print "<table align=\"center\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
      print "<tr><td align=\"left\"  colspan=\"2\">\n";
      print $print_message . $strings['label_dupes']."<br/>&nbsp;";
      print "</td></tr>";
      print "</table>\n";
      print "<table align=\"center\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
    }
    print "<tr><td align=\"left\" colspan=\"6\" >\n";
    print emit_a(generate_link('photo', $photo_identifier['identifier'], array('detail_info'=>3)), $photo_identifier['caption']) ."&nbsp;";
    print "</td></tr>";
    for ($dupes=0; $dupes < pg_num_rows($photo_dupes); $dupes++) {
      $photo_dupe_single = pg_fetch_row($photo_dupes, $dupes);
      print "<tr><td align=\"left\" width=\"4%\">";
      print "<input type=\"checkbox\" name=\"pd$photo_dupe_single[0]\" checked=\"checked\" />";
      print "</td>\n";
      print "<td align=\"left\" width=\"14%\">$photo_identifier[identifier]-$photo_dupe_single[1]</td>";
      print "<td align=\"left\" width=\"20%\">".emit_date_html($photo_dupe_single[2], 'date')."</td>";
      print "<td align=\"left\" width=\"15%\">$photo_dupe_single[5]</td>";
      print "<td align=\"left\" width=\"15%\">$photo_dupe_single[3]:$photo_dupe_single[4]</td>";
      print "<td align=\"left\" width=\"32%\">$photo_dupe_single[6]</td>";
      print "</td></tr>\n";
    }
  }
}

if ($dupes_found == 1) {
  print "</table>\n";
}

print "<input type=\"hidden\" name=\"x_paper\"    value=\"$paper_width\"/>\n";
print "<input type=\"hidden\" name=\"y_paper\"    value=\"$paper_height\"/>\n";
print "<input type=\"hidden\" name=\"paper_name\" value=\"$paper_name\"/>\n";
print "<input type=\"hidden\" name=\"print_type\" value=\"$print_type\"/>\n";

print "<center>";
print $thm_elem['button.print'];
print $thm_elem['button.cancel'];
print "</center>";

print "</form>\n";

site_footer($database);
site_epilog($database);
?>
