<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.php";

function display_folder_search_entry($database, $search_string, $current_user_id) {
  global $thm_elem;
  global $search_interface;
  global $site_url;
  global $strings;

  theme_display_navigator_box_top($search_interface['folder']['idx'], $search_interface, "100%");

  print "<form action=\"".generate_link('search.folder', '')."\" method=\"post\" accept-charset=\"".$strings['formats_encoding']."\">";
  print "<table class=\"search\">";
  print "<tr><td align=\"center\">";
  print "<input type=\"text\" name=\"search_string\" value=\"$search_string\" size=\"50\"/>";
  print "</td>";
  print "<td >";
  print generate_html_users_combo("current_user", $database, $current_user_id, TRUE, FALSE);
  print "</td>";
  print "</tr>";
  print "<tr><td align=\"center\" colspan=\"2\">";
  print $thm_elem['button.search'];
  print "</td></tr>";
  print "</table>";
  print "</form>";

  theme_display_navigator_box_bottom("100%");
}


$folder_id = "";
$album_id = "";

$search_string  = isset($_REQUEST['search_string']) ? $_REQUEST['search_string'] : "";

$search_string  = validate_search_string($search_string);
$current_user_id = isset($_REQUEST['current_user']) ? $_REQUEST['current_user'] : $po_user['id'];
if ($current_user_id == 'null')
  $current_user_id = $po_user['id'];

$master = isset($_REQUEST['only_masters']);  

if (!$current_user_id || ($current_user_id=="all")) {
  $current_user_id = "null";
  $sql_folder_users_string = " ";
  $sql_album_users_string = " ";
} else {
  $sql_folder_users_string = " and folder.users = $current_user_id ";
  $sql_album_users_string = " and album.users = $current_user_id ";
}

$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$order_by = $po_options['order_by'];

$database      = site_prolog();

site_header($strings['generic_search']);

site_navigator(2);

$keywords = extract_keywords($search_string, $po_options['search_enable_stemming']);

if (!$keywords) {
  site_navigator_status($strings['search_string'], "");
  display_folder_search_entry($database, $search_string, $current_user_id);

  site_footer($database);
  site_epilog($database);
  exit();
}

$num_of_matches = 0;

$status_string = $strings['search_albums_found'];

$order_by = $po_options['folder_order_by'];
$sql_query_order_by_string = $folder_order_by_string[$order_by][0];

$sql_search_string = build_sql_search_string($keywords, "folder.caption");
$sql_search_string .= " OR " . build_sql_search_string($keywords, "folder.description");
$sql_query_access_rights_string = "can_access_folder(folder.identifier, $po_user[id], '{".$passwords."}')"; 

$search_result_f = pg_query($database,
			    "select caption, folder.identifier, date_of_creation, folder.date_changed,
                first_name, last_name, users.identifier as user_id, 
                count_subfolders_by_folder(folder.identifier, $po_user[id], '{".$passwords."}') as subs,
                count_photos_by_folder(folder.identifier, $po_user[id], '{".$passwords."}') as photos, thumb_ver
           from folder, users
          where ($sql_search_string)
                $sql_folder_users_string
            and $sql_query_access_rights_string
            and users.identifier = folder.users
          order by $sql_query_order_by_string");

$sql_search_string = build_sql_search_string($keywords, "album.caption");
$sql_search_string .= " OR " . build_sql_search_string($keywords, "album.description");

$sql_query_access_rights_string = "can_access_album(album.identifier, $po_user[id], '{".$passwords."}')"; 

$search_result_a = pg_query($database,
        "select caption, album.identifier, date_of_creation, album.date_changed,
                first_name, last_name, users.identifier as user_id,
                count_subalbums_by_album(album.identifier, $po_user[id], '{".$passwords."}') as subs, 
                count_photos_by_album(album.identifier, $po_user[id], '{".$passwords."}') as photos, thumb_ver
           from album, users
          where ($sql_search_string)
                $sql_album_users_string
            and $sql_query_access_rights_string
            and users.identifier = album.users
          order by $sql_query_order_by_string");

$num_of_matches  = pg_num_rows($search_result_f) + pg_num_rows($search_result_a);

if ($num_of_matches == 0) {
  $itemized_search_string = build_folder_search_string($search_string, "search_string", "");
  site_navigator_status($strings['search_no_matches']." $itemized_search_string", "");
  display_folder_search_entry($database, $search_string, $current_user_id);

  site_footer($database);
  site_epilog($database);
  exit();
}

$itemized_search_string = build_folder_search_string($search_string, "search_string", "");
site_navigator_status($strings['search_searched_for']." $itemized_search_string",  $status_string. " " . display_photo_index_status($offset, 0, $num_of_matches));
display_folder_search_entry($database, $search_string, $current_user_id);

$sstr = urlencode($search_string);
$uri = generate_link('search.folder', $sstr, array('current_user'=>$current_user_id));

if (pg_num_rows($search_result_f) > 0) {
  $search_result_f = pg_fetch_all($search_result_f);
  really_display_folders($search_result_f, FALSE, TRUE, "", 0, $uri);
}
if (pg_num_rows($search_result_a) > 0) {
  $search_result_a = pg_fetch_all($search_result_a);
  really_display_albums($search_result_a, FALSE, TRUE, "", 0, $uri);
}

$itemized_search_string = build_folder_search_string($search_string, "search_string", "");

site_navigator_status($strings['search_searched_for'] ." $itemized_search_string",  $status_string ." " . display_photo_index_status($offset, 0, $num_of_matches));

site_footer($database);
site_epilog($database);
?>
