<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/stemming.php";
include_once "include/search.php";

$search_data = isset($_REQUEST['keyword']) ? validate_search_string($_REQUEST['keyword']) : "";
$master = isset($_REQUEST['only_masters']);

$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$arguments = array();

$order_by = $po_options['order_by'];

$database      = site_prolog();

$keywords = extract_keywords($search_data, $po_options['search_enable_stemming']);

if (!$search_data) {

  site_header($strings['generic_search']);
  site_navigator(2);

  if (!$master && ($po_options['search_masters_only'] != 'f')) {
    $master = TRUE;
  } 

  if ($master) {
    $arguments['only_masters'] = 'true';
  }

  site_navigator_status($strings['search_string'], "");

  $tags = pg_query($database, "select keyword, count(photo) from photo_keywords where can_access_photo(photo, $po_user[id], '{".$passwords."}') group by keyword");

  include_once 'include/wordcloud/wordcloud.class.php';
  print '<link rel="stylesheet" href="include/wordcloud/wordcloud.css" type="text/css">';
  $cloud = new wordCloud();
  for ($i = 0 ; $i < pg_num_rows($tags) ; $i++) {
    $tag = pg_fetch_row($tags);
    $cloud->addWord(array('word'=>$tag[0],'size'=>$tag[1],'url'=>generate_link('tag',$tag[0], $arguments)));
  }

  //  $cloud->setLimit(4);
  print "<div id=\"cloud\">";
  $myCloud = $cloud->showCloud('array');
  foreach ($myCloud as $item) {
    echo ' &nbsp; <a href="'.$item['url'].'" class="word size'.$item['range'].'">'.$item['word'].'</a> &nbsp;';
  }
  print "</div>";

  site_footer($database);
  site_epilog($database);
  exit();
}

$rss = "<link rel=\"alternate\" type=\"application/rss+xml\" title=\"$site_title : $search_data - RSS\" href=\"$site_url/feed.php?type=photos&amp;subtype=tag&amp;id=$search_data\" />";

site_header($strings['generic_search'], "", $rss);
site_navigator(2);

if ($master) {
  $arguments['only_masters'] = 'true';
}

$sql_combined_search_string = build_sql_search_string_keywords($keywords);

if (!$offset) {
  $offset = 0;
}

if ($po_options['photo_view'] == "slide") {
  $limit = $po_options['photos_per_page'];
 } else {
  $limit = $po_options['rows_list_view'];
 }

if ($master)
  $master_args = "and photo_version.master = 't'";
 else
  $master_args = "";

$filter = " ($sql_combined_search_string)
            $master_args";

$search_result = get_photo_query($database, array(), array(), $filter, 0, 0, $order_by);
$num_of_matches = sizeof($search_result);

/* Sanity checks */
if ($limit > $num_of_matches) {
  $limit = $num_of_matches;
 }
while ($num_of_matches && $offset >= $num_of_matches) {
  $offset -= $limit;
 }
if ($offset < 0) {
  $offset = 0;
 }
if (($offset + $limit) > $num_of_matches) {
  $items = $num_of_matches - $offset;
 } else {
  $items = $limit;
 }

site_navigator_status($strings['search_searched_for']."<strong>$search_data</strong>",  $strings['search_displaying'] ." ". display_photo_index_status($offset, $limit, $num_of_matches));

print "&nbsp;<br/>\n";

$search_string = "keyword=".$search_data;
$search_string_exp = str_replace(" ", "+", $search_string);

print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\" accept-charset=\"".$strings['formats_encoding']."\">";
print "<input type=\"hidden\" name=\"return\" value=\"".generate_link('tag', $search_data, array('offset'=>$offset))."\"/>";

display_photo_navigator(generate_link('tag', $search_data, $arguments), $offset, $limit, $num_of_matches);

if ($po_options['photo_view'] == "slide") {
  $checkboxes = display_photo_slides("search_advanced", FALSE, $search_result, $offset, $items, true, true); 
 } else {
  $checkboxes = display_photo_list("search_advanced", FALSE, $search_result, $offset, $items);
 }
display_photo_navigator(generate_link('tag', $search_data, $arguments), $offset, $limit, $num_of_matches);

print "&nbsp;<br/>\n";

site_navigator_status($strings['search_searched_for']."<strong>$search_data</strong>",  $strings['search_displaying'] ." ". display_photo_index_status($offset, $limit, $num_of_matches));

print "<div class=\"actions\">";

if ($checkboxes !== FALSE) {
  display_order_by_combo_with_button($order_by);
  
  if ($po_options['photo_view'] == 'slide') {
    print emit_photos_per_page_combo('photos_per_page', $po_options['photos_per_page']);
  } else {
    print emit_photos_per_page_combo('rows_list_view', $po_options['rows_list_view']);
  }
 }

print "<table><tr><td>\n";

if ($checkboxes != FALSE) {
  display_list_slide_option($po_options['photo_view'], generate_link('tag', $search_data, $arguments));
 }

if ($checkboxes > 0 && $po_user['id']) {
  theme_display_selectButton();
  print $thm_elem['button.add.to.spool'];
  print $thm_elem['button.bulk.update'];
 } 

print "</td></tr></table>\n";

if ($checkboxes > 0 && $po_user['id']) {
  $album_all = get_users_album($database);
  $folder_all = get_users_folder($database);
  print emit_folder_actions($folder_all, $folder_id);
  if (count($album_all)) {
    print emit_album_actions($album_all, $album_id);
  }
}

if ($po_user['id']) {
  print emit_spool_actions($database, $po_user['id']);
  print emit_import_actions($database, $po_user['id']);
 }

print "</div>";

print "</form>";

print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
